#!/usr/bin/perl -w

use strict;
use HTML::Parser;
use LWP::UserAgent;
use URI::URL;

my %LINKS;
my %GOOD_LINKS;
my %BAD_LINKS;
my $BASE;
my @TO_CHECK;
my $URL = $ARGV[0] || "http://mydomain.com";

{
    package GetLinks;
    use base 'HTML::Parser';

    sub start {
            my $self = shift;
            my ($tag, $tag_attr) = @_;
            if ($tag eq 'a' and defined $tag_attr->{href}) {
                    $LINKS{$tag_attr->{href}} = 0;
            }
            if ($tag eq 'img' and defined $tag_attr->{src}) {
                    $LINKS{$tag_attr->{src}} = 0;
            }
    }
}

my $ua = new LWP::UserAgent;
$ua->agent("LinkCheck/0.1");

print "Starting scan from $URL\n";

my $req = new HTTP::Request('GET',$URL);
my $res = $ua->request($req);

if (!$res->is_success) {
    die "Can't fetch $URL";
}

$BASE = $res->base;

my $parser = GetLinks->new;
$parser->parse($res->content);

for my $link (keys %LINKS) {
    my $true_url = url($link, $BASE)->abs;
    push(@TO_CHECK, $true_url);
}

while (my $url = shift @TO_CHECK) {
    next if exists $GOOD_LINKS{$url} or exists $BAD_LINKS{$url};
    $req = new HTTP::Request('GET', $url);
    $res = $ua->request($req);


    if ($res->is_success) {
            if ($res->content_type =~ /text\/html/i && $url =~  {
                    my $parser = GetLinks->new;
                    $parser->parse($res->content);
                    for my $link (keys %LINKS) {
                            my $abs = url($link, $BASE)->abs;
                            unless(exists $GOOD_LINKS{$abs} or BAD_LINKS{$abs}) {
                                    push(@TO_CHECK, $abs);
                            }
                    }
            }
            $GOOD_LINKS{$url}++;
    } else {
            $BAD_LINKS{$url}++;
    }
}

print qq{Bad links\n};
print qq{$_\n} for keys %BAD_LINKS;

